Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class HashSet

    java.lang.Object
      |
      +--java.util.AbstractCollection
            |
            +--java.util.AbstractSet
                  |
                  +--java.util.HashSet

All Implemented Interfaces:
  Cloneable, Collection, Serializable, Set

Direct Known Subclasses:
  JobStateReasons, LinkedHashSet

public class HashSet
extends AbstractSet
implements Set, Cloneable, Serializable

This class implements the `Set` interface, backed by a hash table (actually a `HashMap` instance). It makes no guarantees as to the iteration order of the set; in particular, it does not guarantee that the order will remain constant over time. This class permits the `null` element.

This class offers constant time performance for the basic operations (`add`, `remove`, `contains` and `size`), assuming the hash function disperses the elements properly among the buckets. Iterating over this set requires time proportional to the sum of the `HashSet` instance's size (the number of elements) plus the "capacity" of the backing `HashMap` instance (the number of buckets). Thus, it's very important not to set the initial capacity too high (or the load factor too low) if iteration performance is important.

Note that this implementation is not synchronized. If multiple threads access a set concurrently, and at least one of the threads modifies the set, it must be synchronized externally. This is typically accomplished by synchronizing on some object that naturally encapsulates the set. If no such object exists, the set should be "wrapped" using the `Collections.synchronizedSet` method. This is best done at creation time, to prevent accidental unsynchronized access to the `HashSet` instance:

         Set s = Collections.synchronizedSet(new HashSet(...));

The iterators returned by this class's `iterator` method are fail-fast: if the set is modified at any time after the iterator is created, in any way except through the iterator's own `remove` method, the Iterator throws a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Note that the fail-fast behavior of an iterator cannot be guaranteed as it is, generally speaking, impossible to make any hard guarantees in the presence of unsynchronized concurrent modification. Fail-fast iterators throw `ConcurrentModificationException` on a best-effort basis. Therefore, it would be wrong to write a program that depended on this exception for its correctness: the fail-fast behavior of iterators should be used only to detect bugs.

Since:
  1.2
See Also:
  `Collection`, `Set`, `TreeSet`, `Collections.synchronizedSet(Set)`, `HashMap`, Serialized Form

Constructor Summary
`HashSet()` Constructs a new, empty set; the backing `HashMap` instance has default initial capacity (16) and load factor (0.75).
`HashSet(Collection c)` Constructs a new set containing the elements in the specified collection.
`HashSet(int initialCapacity)` Constructs a new, empty set; the backing `HashMap` instance has the specified initial capacity and default load factor, which is `0.75`.
`HashSet(int initialCapacity, float loadFactor)` Constructs a new, empty set; the backing `HashMap` instance has the specified initial capacity and the specified load factor.

Method Summary
`boolean` | `add(Object o)` Adds the specified element to this set if it is not already present.
`void` | `clear()` Removes all of the elements from this set.
`Object` | `clone()` Returns a shallow copy of this `HashSet` instance: the elements themselves are not cloned.
`boolean` | `contains(Object o)` Returns `true` if this set contains the specified element.
`boolean` | `isEmpty()` Returns `true` if this set contains no elements.
`Iterator` | `iterator()` Returns an iterator over the elements in this set.
`boolean` | `remove(Object o)` Removes the specified element from this set if it is present.
`int` | `size()` Returns the number of elements in this set (its cardinality).

Methods inherited from class java.util.AbstractSet
`equals, hashCode, removeAll`

Methods inherited from class java.util.AbstractCollection
`addAll, containsAll, retainAll, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`addAll, containsAll, equals, hashCode, removeAll, retainAll, toArray, toArray`

Constructor Detail

### HashSet

    public HashSet()

  Constructs a new, empty set; the backing `HashMap` instance has default initial capacity (16) and load factor (0.75).

### HashSet

    public HashSet(Collection c)

  Constructs a new set containing the elements in the specified collection. The `HashMap` is created with default load factor (0.75) and an initial capacity sufficient to contain the elements in the specified collection.

Parameters:
  `c` - the collection whose elements are to be placed into this set.
Throws:
  `NullPointerException` - if the specified collection is null.

### HashSet

    public HashSet(int initialCapacity,
                   float loadFactor)

  Constructs a new, empty set; the backing `HashMap` instance has the specified initial capacity and the specified load factor.

Parameters:
  `initialCapacity` - the initial capacity of the hash map.
  `loadFactor` - the load factor of the hash map.
Throws:
  `IllegalArgumentException` - if the initial capacity is less than zero, or if the load factor is nonpositive.

### HashSet

    public HashSet(int initialCapacity)

  Constructs a new, empty set; the backing `HashMap` instance has the specified initial capacity and default load factor, which is `0.75`.

Parameters:
  `initialCapacity` - the initial capacity of the hash table.
Throws:
  `IllegalArgumentException` - if the initial capacity is less than zero.

Method Detail

### iterator

    public Iterator iterator()

  Returns an iterator over the elements in this set. The elements are returned in no particular order.

  Specified by:
    `iterator` in interface `Set`
  Specified by:
    `iterator` in class `AbstractCollection`
  Returns:
    an Iterator over the elements in this set.
  See Also:
    `ConcurrentModificationException`

### size

    public int size()

  Returns the number of elements in this set (its cardinality).

  Specified by:
    `size` in interface `Set`
  Specified by:
    `size` in class `AbstractCollection`
  Returns:
    the number of elements in this set (its cardinality).

### isEmpty

    public boolean isEmpty()

  Returns `true` if this set contains no elements.

  Specified by:
    `isEmpty` in interface `Set`
  Overrides:
    `isEmpty` in class `AbstractCollection`
  Returns:
    `true` if this set contains no elements.

### contains

    public boolean contains(Object o)

  Returns `true` if this set contains the specified element.

  Specified by:
    `contains` in interface `Set`
  Overrides:
    `contains` in class `AbstractCollection`
  Parameters:
    `o` - element whose presence in this set is to be tested.
  Returns:
    `true` if this set contains the specified element.

### add

    public boolean add(Object o)

  Adds the specified element to this set if it is not already present.

  Specified by:
    `add` in interface `Set`
  Overrides:
    `add` in class `AbstractCollection`
  Parameters:
    `o` - element to be added to this set.
  Returns:
    `true` if the set did not already contain the specified element.

### remove

    public boolean remove(Object o)

  Removes the specified element from this set if it is present.

  Specified by:
    `remove` in interface `Set`
  Overrides:
    `remove` in class `AbstractCollection`
  Parameters:
    `o` - object to be removed from this set, if present.
  Returns:
    `true` if the set contained the specified element.

### clear

    public void clear()

  Removes all of the elements from this set.

  Specified by:
    `clear` in interface `Set`
  Overrides:
    `clear` in class `AbstractCollection`

### clone

    public Object clone()

  Returns a shallow copy of this `HashSet` instance: the elements themselves are not cloned.

  Overrides:
    `clone` in class `Object`
  Returns:
    a shallow copy of this set.
  See Also:
    `Cloneable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.